SystemOrganization addCategory: #'TP2-TADP'!

Object subclass: #TheInterceptor
	instanceVariableNames: 'afterCode beforeCode theClasses theMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:18'!
addACategory: unaCategoriaString
	theClasses addAll: (Object subclasses select: [ :aClass | aClass category == (unaCategoriaString asSymbol)]).

! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:28'!
addClasses: anString
	| classesNames |
	classesNames := anString subStrings: ' '.
	theClasses addAll: (classesNames collect: [ :name | Compiler evaluate: name]).! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
agregarCodigo
	| codes |
	codes := self getTheMethods collect: [ :method | self getBeforeCode , method sourceCode, self getAfterCode ].
	^codes! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:45'!
getAfterCode
	
	^ afterCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
getBeforeCode
	
	^ beforeCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:24'!
getTheClasses
	
	^ theClasses! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
getTheMethods
	
	^ theMethods! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:27'!
initialize 
	theClasses := Bag new.
	theMethods := Bag new.! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:35'!
methodsBeginWith: anString
	| allMethods |
	allMethods := (theClasses collect: [ :aClass | aClass methods]).
	^ allMethods gather: [ :arrayMethods | arrayMethods select:  [:aMethod | (aMethod selector beginsWith: anString asSymbol)]].! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:37'!
selectAccessors
	theMethods addAll: (self methodsBeginWith: 'set').
	theMethods addAll: (self methodsBeginWith: 'get').! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:36'!
selectMethodsBeginWith: anString
	theMethods addAll: (self methodsBeginWith: anString)! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:46'!
setAfterCode: anObject
	
	afterCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
setBeforeCode: anObject
	
	beforeCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:23'!
setTheClasses: anObject
	
	theClasses := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
setTheMethods: anObject
	
	theMethods := anObject! !
